Index: issm/trunk/src/m/enum/EnumDefinitions.py
===================================================================
--- issm/trunk/src/m/enum/EnumDefinitions.py	(revision 12709)
+++ issm/trunk/src/m/enum/EnumDefinitions.py	(revision 13395)
@@ -3685,5 +3927,335 @@
 	"""
 
-	return StringToEnum('StressTensorzz')
+	return StringToEnum('StressTensorzz')[0]
+
+def P0Enum():
+	"""
+	P0ENUM - Enum of P0
+
+	   Usage:
+	      macro=P0Enum()
+	"""
+
+	return StringToEnum('P0')[0]
+
+def P1Enum():
+	"""
+	P1ENUM - Enum of P1
+
+	   Usage:
+	      macro=P1Enum()
+	"""
+
+	return StringToEnum('P1')[0]
+
+def P1DGEnum():
+	"""
+	P1DGENUM - Enum of P1DG
+
+	   Usage:
+	      macro=P1DGEnum()
+	"""
+
+	return StringToEnum('P1DG')[0]
+
+def SaveResultsEnum():
+	"""
+	SAVERESULTSENUM - Enum of SaveResults
+
+	   Usage:
+	      macro=SaveResultsEnum()
+	"""
+
+	return StringToEnum('SaveResults')[0]
+
+def BoolElementResultEnum():
+	"""
+	BOOLELEMENTRESULTENUM - Enum of BoolElementResult
+
+	   Usage:
+	      macro=BoolElementResultEnum()
+	"""
+
+	return StringToEnum('BoolElementResult')[0]
+
+def BoolExternalResultEnum():
+	"""
+	BOOLEXTERNALRESULTENUM - Enum of BoolExternalResult
+
+	   Usage:
+	      macro=BoolExternalResultEnum()
+	"""
+
+	return StringToEnum('BoolExternalResult')[0]
+
+def DoubleElementResultEnum():
+	"""
+	DOUBLEELEMENTRESULTENUM - Enum of DoubleElementResult
+
+	   Usage:
+	      macro=DoubleElementResultEnum()
+	"""
+
+	return StringToEnum('DoubleElementResult')[0]
+
+def DoubleExternalResultEnum():
+	"""
+	DOUBLEEXTERNALRESULTENUM - Enum of DoubleExternalResult
+
+	   Usage:
+	      macro=DoubleExternalResultEnum()
+	"""
+
+	return StringToEnum('DoubleExternalResult')[0]
+
+def DoubleMatExternalResultEnum():
+	"""
+	DOUBLEMATEXTERNALRESULTENUM - Enum of DoubleMatExternalResult
+
+	   Usage:
+	      macro=DoubleMatExternalResultEnum()
+	"""
+
+	return StringToEnum('DoubleMatExternalResult')[0]
+
+def DoubleVecExternalResultEnum():
+	"""
+	DOUBLEVECEXTERNALRESULTENUM - Enum of DoubleVecExternalResult
+
+	   Usage:
+	      macro=DoubleVecExternalResultEnum()
+	"""
+
+	return StringToEnum('DoubleVecExternalResult')[0]
+
+def IntExternalResultEnum():
+	"""
+	INTEXTERNALRESULTENUM - Enum of IntExternalResult
+
+	   Usage:
+	      macro=IntExternalResultEnum()
+	"""
+
+	return StringToEnum('IntExternalResult')[0]
+
+def JEnum():
+	"""
+	JENUM - Enum of J
+
+	   Usage:
+	      macro=JEnum()
+	"""
+
+	return StringToEnum('J')[0]
+
+def PatchEnum():
+	"""
+	PATCHENUM - Enum of Patch
+
+	   Usage:
+	      macro=PatchEnum()
+	"""
+
+	return StringToEnum('Patch')[0]
+
+def PatchNodesEnum():
+	"""
+	PATCHNODESENUM - Enum of PatchNodes
+
+	   Usage:
+	      macro=PatchNodesEnum()
+	"""
+
+	return StringToEnum('PatchNodes')[0]
+
+def PatchVerticesEnum():
+	"""
+	PATCHVERTICESENUM - Enum of PatchVertices
+
+	   Usage:
+	      macro=PatchVerticesEnum()
+	"""
+
+	return StringToEnum('PatchVertices')[0]
+
+def PentaP1ElementResultEnum():
+	"""
+	PENTAP1ELEMENTRESULTENUM - Enum of PentaP1ElementResult
+
+	   Usage:
+	      macro=PentaP1ElementResultEnum()
+	"""
+
+	return StringToEnum('PentaP1ElementResult')[0]
+
+def PetscVecExternalResultEnum():
+	"""
+	PETSCVECEXTERNALRESULTENUM - Enum of PetscVecExternalResult
+
+	   Usage:
+	      macro=PetscVecExternalResultEnum()
+	"""
+
+	return StringToEnum('PetscVecExternalResult')[0]
+
+def StringExternalResultEnum():
+	"""
+	STRINGEXTERNALRESULTENUM - Enum of StringExternalResult
+
+	   Usage:
+	      macro=StringExternalResultEnum()
+	"""
+
+	return StringToEnum('StringExternalResult')[0]
+
+def StepEnum():
+	"""
+	STEPENUM - Enum of Step
+
+	   Usage:
+	      macro=StepEnum()
+	"""
+
+	return StringToEnum('Step')[0]
+
+def TimeEnum():
+	"""
+	TIMEENUM - Enum of Time
+
+	   Usage:
+	      macro=TimeEnum()
+	"""
+
+	return StringToEnum('Time')[0]
+
+def TriaP1ElementResultEnum():
+	"""
+	TRIAP1ELEMENTRESULTENUM - Enum of TriaP1ElementResult
+
+	   Usage:
+	      macro=TriaP1ElementResultEnum()
+	"""
+
+	return StringToEnum('TriaP1ElementResult')[0]
+
+def WaterColumnOldEnum():
+	"""
+	WATERCOLUMNOLDENUM - Enum of WaterColumnOld
+
+	   Usage:
+	      macro=WaterColumnOldEnum()
+	"""
+
+	return StringToEnum('WaterColumnOld')[0]
+
+def MinVelEnum():
+	"""
+	MINVELENUM - Enum of MinVel
+
+	   Usage:
+	      macro=MinVelEnum()
+	"""
+
+	return StringToEnum('MinVel')[0]
+
+def MaxVelEnum():
+	"""
+	MAXVELENUM - Enum of MaxVel
+
+	   Usage:
+	      macro=MaxVelEnum()
+	"""
+
+	return StringToEnum('MaxVel')[0]
+
+def MinVxEnum():
+	"""
+	MINVXENUM - Enum of MinVx
+
+	   Usage:
+	      macro=MinVxEnum()
+	"""
+
+	return StringToEnum('MinVx')[0]
+
+def MaxVxEnum():
+	"""
+	MAXVXENUM - Enum of MaxVx
+
+	   Usage:
+	      macro=MaxVxEnum()
+	"""
+
+	return StringToEnum('MaxVx')[0]
+
+def MaxAbsVxEnum():
+	"""
+	MAXABSVXENUM - Enum of MaxAbsVx
+
+	   Usage:
+	      macro=MaxAbsVxEnum()
+	"""
+
+	return StringToEnum('MaxAbsVx')[0]
+
+def MinVyEnum():
+	"""
+	MINVYENUM - Enum of MinVy
+
+	   Usage:
+	      macro=MinVyEnum()
+	"""
+
+	return StringToEnum('MinVy')[0]
+
+def MaxVyEnum():
+	"""
+	MAXVYENUM - Enum of MaxVy
+
+	   Usage:
+	      macro=MaxVyEnum()
+	"""
+
+	return StringToEnum('MaxVy')[0]
+
+def MaxAbsVyEnum():
+	"""
+	MAXABSVYENUM - Enum of MaxAbsVy
+
+	   Usage:
+	      macro=MaxAbsVyEnum()
+	"""
+
+	return StringToEnum('MaxAbsVy')[0]
+
+def MinVzEnum():
+	"""
+	MINVZENUM - Enum of MinVz
+
+	   Usage:
+	      macro=MinVzEnum()
+	"""
+
+	return StringToEnum('MinVz')[0]
+
+def MaxVzEnum():
+	"""
+	MAXVZENUM - Enum of MaxVz
+
+	   Usage:
+	      macro=MaxVzEnum()
+	"""
+
+	return StringToEnum('MaxVz')[0]
+
+def MaxAbsVzEnum():
+	"""
+	MAXABSVZENUM - Enum of MaxAbsVz
+
+	   Usage:
+	      macro=MaxAbsVzEnum()
+	"""
+
+	return StringToEnum('MaxAbsVz')[0]
 
 def IceVolumeEnum():
@@ -3695,335 +4267,15 @@
 	"""
 
-	return StringToEnum('IceVolume')
-
-def P0Enum():
-	"""
-	P0ENUM - Enum of P0
-
-	   Usage:
-	      macro=P0Enum()
-	"""
-
-	return StringToEnum('P0')
-
-def P1Enum():
-	"""
-	P1ENUM - Enum of P1
-
-	   Usage:
-	      macro=P1Enum()
-	"""
-
-	return StringToEnum('P1')
-
-def P1DGEnum():
-	"""
-	P1DGENUM - Enum of P1DG
-
-	   Usage:
-	      macro=P1DGEnum()
-	"""
-
-	return StringToEnum('P1DG')
-
-def SaveResultsEnum():
-	"""
-	SAVERESULTSENUM - Enum of SaveResults
-
-	   Usage:
-	      macro=SaveResultsEnum()
-	"""
-
-	return StringToEnum('SaveResults')
-
-def BoolElementResultEnum():
-	"""
-	BOOLELEMENTRESULTENUM - Enum of BoolElementResult
-
-	   Usage:
-	      macro=BoolElementResultEnum()
-	"""
-
-	return StringToEnum('BoolElementResult')
-
-def BoolExternalResultEnum():
-	"""
-	BOOLEXTERNALRESULTENUM - Enum of BoolExternalResult
-
-	   Usage:
-	      macro=BoolExternalResultEnum()
-	"""
-
-	return StringToEnum('BoolExternalResult')
-
-def DoubleElementResultEnum():
-	"""
-	DOUBLEELEMENTRESULTENUM - Enum of DoubleElementResult
-
-	   Usage:
-	      macro=DoubleElementResultEnum()
-	"""
-
-	return StringToEnum('DoubleElementResult')
-
-def DoubleExternalResultEnum():
-	"""
-	DOUBLEEXTERNALRESULTENUM - Enum of DoubleExternalResult
-
-	   Usage:
-	      macro=DoubleExternalResultEnum()
-	"""
-
-	return StringToEnum('DoubleExternalResult')
-
-def DoubleMatExternalResultEnum():
-	"""
-	DOUBLEMATEXTERNALRESULTENUM - Enum of DoubleMatExternalResult
-
-	   Usage:
-	      macro=DoubleMatExternalResultEnum()
-	"""
-
-	return StringToEnum('DoubleMatExternalResult')
-
-def DoubleVecExternalResultEnum():
-	"""
-	DOUBLEVECEXTERNALRESULTENUM - Enum of DoubleVecExternalResult
-
-	   Usage:
-	      macro=DoubleVecExternalResultEnum()
-	"""
-
-	return StringToEnum('DoubleVecExternalResult')
-
-def IntExternalResultEnum():
-	"""
-	INTEXTERNALRESULTENUM - Enum of IntExternalResult
-
-	   Usage:
-	      macro=IntExternalResultEnum()
-	"""
-
-	return StringToEnum('IntExternalResult')
-
-def JEnum():
-	"""
-	JENUM - Enum of J
-
-	   Usage:
-	      macro=JEnum()
-	"""
-
-	return StringToEnum('J')
-
-def PatchEnum():
-	"""
-	PATCHENUM - Enum of Patch
-
-	   Usage:
-	      macro=PatchEnum()
-	"""
-
-	return StringToEnum('Patch')
-
-def PatchNodesEnum():
-	"""
-	PATCHNODESENUM - Enum of PatchNodes
-
-	   Usage:
-	      macro=PatchNodesEnum()
-	"""
-
-	return StringToEnum('PatchNodes')
-
-def PatchVerticesEnum():
-	"""
-	PATCHVERTICESENUM - Enum of PatchVertices
-
-	   Usage:
-	      macro=PatchVerticesEnum()
-	"""
-
-	return StringToEnum('PatchVertices')
-
-def PentaP1ElementResultEnum():
-	"""
-	PENTAP1ELEMENTRESULTENUM - Enum of PentaP1ElementResult
-
-	   Usage:
-	      macro=PentaP1ElementResultEnum()
-	"""
-
-	return StringToEnum('PentaP1ElementResult')
-
-def PetscVecExternalResultEnum():
-	"""
-	PETSCVECEXTERNALRESULTENUM - Enum of PetscVecExternalResult
-
-	   Usage:
-	      macro=PetscVecExternalResultEnum()
-	"""
-
-	return StringToEnum('PetscVecExternalResult')
-
-def StringExternalResultEnum():
-	"""
-	STRINGEXTERNALRESULTENUM - Enum of StringExternalResult
-
-	   Usage:
-	      macro=StringExternalResultEnum()
-	"""
-
-	return StringToEnum('StringExternalResult')
-
-def StepEnum():
-	"""
-	STEPENUM - Enum of Step
-
-	   Usage:
-	      macro=StepEnum()
-	"""
-
-	return StringToEnum('Step')
-
-def TimeEnum():
-	"""
-	TIMEENUM - Enum of Time
-
-	   Usage:
-	      macro=TimeEnum()
-	"""
-
-	return StringToEnum('Time')
-
-def TriaP1ElementResultEnum():
-	"""
-	TRIAP1ELEMENTRESULTENUM - Enum of TriaP1ElementResult
-
-	   Usage:
-	      macro=TriaP1ElementResultEnum()
-	"""
-
-	return StringToEnum('TriaP1ElementResult')
-
-def WaterColumnOldEnum():
-	"""
-	WATERCOLUMNOLDENUM - Enum of WaterColumnOld
-
-	   Usage:
-	      macro=WaterColumnOldEnum()
-	"""
-
-	return StringToEnum('WaterColumnOld')
-
-def MinVelEnum():
-	"""
-	MINVELENUM - Enum of MinVel
-
-	   Usage:
-	      macro=MinVelEnum()
-	"""
-
-	return StringToEnum('MinVel')
-
-def MaxVelEnum():
-	"""
-	MAXVELENUM - Enum of MaxVel
-
-	   Usage:
-	      macro=MaxVelEnum()
-	"""
-
-	return StringToEnum('MaxVel')
-
-def MinVxEnum():
-	"""
-	MINVXENUM - Enum of MinVx
-
-	   Usage:
-	      macro=MinVxEnum()
-	"""
-
-	return StringToEnum('MinVx')
-
-def MaxVxEnum():
-	"""
-	MAXVXENUM - Enum of MaxVx
-
-	   Usage:
-	      macro=MaxVxEnum()
-	"""
-
-	return StringToEnum('MaxVx')
-
-def MaxAbsVxEnum():
-	"""
-	MAXABSVXENUM - Enum of MaxAbsVx
-
-	   Usage:
-	      macro=MaxAbsVxEnum()
-	"""
-
-	return StringToEnum('MaxAbsVx')
-
-def MinVyEnum():
-	"""
-	MINVYENUM - Enum of MinVy
-
-	   Usage:
-	      macro=MinVyEnum()
-	"""
-
-	return StringToEnum('MinVy')
-
-def MaxVyEnum():
-	"""
-	MAXVYENUM - Enum of MaxVy
-
-	   Usage:
-	      macro=MaxVyEnum()
-	"""
-
-	return StringToEnum('MaxVy')
-
-def MaxAbsVyEnum():
-	"""
-	MAXABSVYENUM - Enum of MaxAbsVy
-
-	   Usage:
-	      macro=MaxAbsVyEnum()
-	"""
-
-	return StringToEnum('MaxAbsVy')
-
-def MinVzEnum():
-	"""
-	MINVZENUM - Enum of MinVz
-
-	   Usage:
-	      macro=MinVzEnum()
-	"""
-
-	return StringToEnum('MinVz')
-
-def MaxVzEnum():
-	"""
-	MAXVZENUM - Enum of MaxVz
-
-	   Usage:
-	      macro=MaxVzEnum()
-	"""
-
-	return StringToEnum('MaxVz')
-
-def MaxAbsVzEnum():
-	"""
-	MAXABSVZENUM - Enum of MaxAbsVz
-
-	   Usage:
-	      macro=MaxAbsVzEnum()
-	"""
-
-	return StringToEnum('MaxAbsVz')
+	return StringToEnum('IceVolume')[0]
+
+def TotalSmbEnum():
+	"""
+	TOTALSMBENUM - Enum of TotalSmb
+
+	   Usage:
+	      macro=TotalSmbEnum()
+	"""
+
+	return StringToEnum('TotalSmb')[0]
 
 def RelativeEnum():
@@ -4035,5 +4287,5 @@
 	"""
 
-	return StringToEnum('Relative')
+	return StringToEnum('Relative')[0]
 
 def AbsoluteEnum():
@@ -4045,5 +4297,5 @@
 	"""
 
-	return StringToEnum('Absolute')
+	return StringToEnum('Absolute')[0]
 
 def IncrementalEnum():
@@ -4055,5 +4307,5 @@
 	"""
 
-	return StringToEnum('Incremental')
+	return StringToEnum('Incremental')[0]
 
 def AgressiveMigrationEnum():
@@ -4065,5 +4317,5 @@
 	"""
 
-	return StringToEnum('AgressiveMigration')
+	return StringToEnum('AgressiveMigration')[0]
 
 def NoneEnum():
@@ -4075,5 +4327,5 @@
 	"""
 
-	return StringToEnum('None')
+	return StringToEnum('None')[0]
 
 def SoftMigrationEnum():
@@ -4085,5 +4337,5 @@
 	"""
 
-	return StringToEnum('SoftMigration')
+	return StringToEnum('SoftMigration')[0]
 
 def StokesSolverEnum():
@@ -4095,5 +4347,5 @@
 	"""
 
-	return StringToEnum('StokesSolver')
+	return StringToEnum('StokesSolver')[0]
 
 def AdjointEnum():
@@ -4105,5 +4357,5 @@
 	"""
 
-	return StringToEnum('Adjoint')
+	return StringToEnum('Adjoint')[0]
 
 def ColinearEnum():
@@ -4115,5 +4367,5 @@
 	"""
 
-	return StringToEnum('Colinear')
+	return StringToEnum('Colinear')[0]
 
 def ControlSteadyEnum():
@@ -4125,5 +4377,5 @@
 	"""
 
-	return StringToEnum('ControlSteady')
+	return StringToEnum('ControlSteady')[0]
 
 def FsetEnum():
@@ -4135,5 +4387,5 @@
 	"""
 
-	return StringToEnum('Fset')
+	return StringToEnum('Fset')[0]
 
 def Gradient1Enum():
@@ -4145,5 +4397,5 @@
 	"""
 
-	return StringToEnum('Gradient1')
+	return StringToEnum('Gradient1')[0]
 
 def Gradient2Enum():
@@ -4155,5 +4407,5 @@
 	"""
 
-	return StringToEnum('Gradient2')
+	return StringToEnum('Gradient2')[0]
 
 def Gradient3Enum():
@@ -4165,5 +4417,5 @@
 	"""
 
-	return StringToEnum('Gradient3')
+	return StringToEnum('Gradient3')[0]
 
 def GradientEnum():
@@ -4175,5 +4427,5 @@
 	"""
 
-	return StringToEnum('Gradient')
+	return StringToEnum('Gradient')[0]
 
 def GroundinglineMigrationEnum():
@@ -4185,5 +4437,5 @@
 	"""
 
-	return StringToEnum('GroundinglineMigration')
+	return StringToEnum('GroundinglineMigration')[0]
 
 def GsetEnum():
@@ -4195,5 +4447,5 @@
 	"""
 
-	return StringToEnum('Gset')
+	return StringToEnum('Gset')[0]
 
 def IndexEnum():
@@ -4205,5 +4457,5 @@
 	"""
 
-	return StringToEnum('Index')
+	return StringToEnum('Index')[0]
 
 def IndexedEnum():
@@ -4215,5 +4467,5 @@
 	"""
 
-	return StringToEnum('Indexed')
+	return StringToEnum('Indexed')[0]
 
 def IntersectEnum():
@@ -4225,5 +4477,5 @@
 	"""
 
-	return StringToEnum('Intersect')
+	return StringToEnum('Intersect')[0]
 
 def NodalEnum():
@@ -4235,5 +4487,5 @@
 	"""
 
-	return StringToEnum('Nodal')
+	return StringToEnum('Nodal')[0]
 
 def OldGradientEnum():
@@ -4245,5 +4497,5 @@
 	"""
 
-	return StringToEnum('OldGradient')
+	return StringToEnum('OldGradient')[0]
 
 def OutputFilePointerEnum():
@@ -4255,5 +4507,5 @@
 	"""
 
-	return StringToEnum('OutputFilePointer')
+	return StringToEnum('OutputFilePointer')[0]
 
 def PetscOptionsAnalysesEnum():
@@ -4265,5 +4517,5 @@
 	"""
 
-	return StringToEnum('PetscOptionsAnalyses')
+	return StringToEnum('PetscOptionsAnalyses')[0]
 
 def PetscOptionsStringsEnum():
@@ -4275,5 +4527,5 @@
 	"""
 
-	return StringToEnum('PetscOptionsStrings')
+	return StringToEnum('PetscOptionsStrings')[0]
 
 def QmuErrNameEnum():
@@ -4285,5 +4537,5 @@
 	"""
 
-	return StringToEnum('QmuErrName')
+	return StringToEnum('QmuErrName')[0]
 
 def QmuInNameEnum():
@@ -4295,5 +4547,5 @@
 	"""
 
-	return StringToEnum('QmuInName')
+	return StringToEnum('QmuInName')[0]
 
 def QmuOutNameEnum():
@@ -4305,5 +4557,5 @@
 	"""
 
-	return StringToEnum('QmuOutName')
+	return StringToEnum('QmuOutName')[0]
 
 def RegularEnum():
@@ -4315,5 +4567,5 @@
 	"""
 
-	return StringToEnum('Regular')
+	return StringToEnum('Regular')[0]
 
 def ScaledEnum():
@@ -4325,5 +4577,5 @@
 	"""
 
-	return StringToEnum('Scaled')
+	return StringToEnum('Scaled')[0]
 
 def SeparateEnum():
@@ -4335,5 +4587,5 @@
 	"""
 
-	return StringToEnum('Separate')
+	return StringToEnum('Separate')[0]
 
 def SsetEnum():
@@ -4345,5 +4597,5 @@
 	"""
 
-	return StringToEnum('Sset')
+	return StringToEnum('Sset')[0]
 
 def VerboseEnum():
@@ -4355,5 +4607,5 @@
 	"""
 
-	return StringToEnum('Verbose')
+	return StringToEnum('Verbose')[0]
 
 def TriangleInterpEnum():
@@ -4365,5 +4617,5 @@
 	"""
 
-	return StringToEnum('TriangleInterp')
+	return StringToEnum('TriangleInterp')[0]
 
 def BilinearInterpEnum():
@@ -4375,5 +4627,5 @@
 	"""
 
-	return StringToEnum('BilinearInterp')
+	return StringToEnum('BilinearInterp')[0]
 
 def NearestInterpEnum():
@@ -4385,5 +4637,5 @@
 	"""
 
-	return StringToEnum('NearestInterp')
+	return StringToEnum('NearestInterp')[0]
 
 def XYEnum():
@@ -4395,5 +4647,5 @@
 	"""
 
-	return StringToEnum('XY')
+	return StringToEnum('XY')[0]
 
 def XYZPEnum():
@@ -4405,5 +4657,5 @@
 	"""
 
-	return StringToEnum('XYZP')
+	return StringToEnum('XYZP')[0]
 
 def OptionEnum():
@@ -4415,5 +4667,15 @@
 	"""
 
-	return StringToEnum('Option')
+	return StringToEnum('Option')[0]
+
+def GenericOptionEnum():
+	"""
+	GENERICOPTIONENUM - Enum of GenericOption
+
+	   Usage:
+	      macro=GenericOptionEnum()
+	"""
+
+	return StringToEnum('GenericOption')[0]
 
 def OptionCellEnum():
@@ -4425,5 +4687,5 @@
 	"""
 
-	return StringToEnum('OptionCell')
+	return StringToEnum('OptionCell')[0]
 
 def OptionCharEnum():
@@ -4435,5 +4697,5 @@
 	"""
 
-	return StringToEnum('OptionChar')
+	return StringToEnum('OptionChar')[0]
 
 def OptionStructEnum():
@@ -4445,5 +4707,5 @@
 	"""
 
-	return StringToEnum('OptionStruct')
+	return StringToEnum('OptionStruct')[0]
 
 def OptionDoubleEnum():
@@ -4455,5 +4717,5 @@
 	"""
 
-	return StringToEnum('OptionDouble')
+	return StringToEnum('OptionDouble')[0]
 
 def OptionLogicalEnum():
@@ -4465,5 +4727,5 @@
 	"""
 
-	return StringToEnum('OptionLogical')
+	return StringToEnum('OptionLogical')[0]
 
 def PatersonEnum():
@@ -4475,5 +4737,5 @@
 	"""
 
-	return StringToEnum('Paterson')
+	return StringToEnum('Paterson')[0]
 
 def ArrheniusEnum():
@@ -4485,5 +4747,5 @@
 	"""
 
-	return StringToEnum('Arrhenius')
+	return StringToEnum('Arrhenius')[0]
 
 def MaximumNumberOfEnums():
@@ -4495,4 +4757,4 @@
 	"""
 
-	return 448
-
+	return 474
+
Index: issm/trunk/src/m/enum/MaximumNumberOfEnums.m
===================================================================
--- issm/trunk/src/m/enum/MaximumNumberOfEnums.m	(revision 12709)
+++ issm/trunk/src/m/enum/MaximumNumberOfEnums.m	(revision 13395)
@@ -9,3 +9,3 @@
 %      macro=MaximumNumberOfEnums()
 
-macro=448;
+macro=474;
Index: issm/trunk/src/m/exp/clicktoflowline.m
===================================================================
--- issm/trunk/src/m/exp/clicktoflowline.m	(revision 13395)
+++ issm/trunk/src/m/exp/clicktoflowline.m	(revision 13395)
@@ -0,0 +1,24 @@
+function clicktoflowline(index,x,y,u,v,filename)
+%CLICKTOFLOWLINE - create a flowline ARGUS file
+%
+%   create a flowline contour file (named 'filename') by clicking
+%   on a velocity field once (velocity must be plotted first)
+%
+%   Usage: 
+%      clicktoflowline(index,x,y,u,v,x0,y0,filename)
+%
+%   Example: 
+%      clicktoflowline(md.mesh.elements,md.mesh.x,md.mesh.y,md.inversion.vx_obs,md.inversion.vy_obs,'flowline.exp')
+
+%Get click position
+[x0,y0]=ginput(1);
+
+%Get flowline
+line=flowlines(index,x,y,u,v,x0,y0,200);
+
+%plot
+hold on
+plot(line.x,line.y,'r-');
+
+%Write argus file
+expwrite(line,filename);
Index: issm/trunk/src/m/exp/downstreamflowlines.m
===================================================================
--- issm/trunk/src/m/exp/downstreamflowlines.m	(revision 13395)
+++ issm/trunk/src/m/exp/downstreamflowlines.m	(revision 13395)
@@ -0,0 +1,110 @@
+function flowpath=downstreamflowlines(index,x,y,u,v,x0,y0,varargin)
+%DOWNSTREAMFLOWLINES - compute flowlines from a given set of seed points
+%
+%   Usage:
+%      flowpath=downstreamflowlines(index,x,y,u,v,x0,y0)
+%
+%   the velocity field is given by the couple (u,v) and the coordinates
+%   of the seed points are (x0,y0). One can use one or several seed 
+%   points
+%
+%   Example:
+%      flowpath=downstreamflowlines(md.mesh.elements,md.mesh.x,md.mesh.y,md.vx,md.initialization.vy,x0,y0)
+
+%check input size
+if nargin>9 | nargin<7,
+	help flowlines
+	error('flowlines error message: bad usage');
+end
+
+%check input
+if (length(x)~=length(y) | length(x)~=length(u) | length(x)~=length(v)),
+	error('flowlines error message: x,y,u and v must have the same length');
+end
+if length(x)<3,
+	error('flowlines error message: at least one element is required');
+end
+if length(x0)~=length(y0),
+	error('flowlines error message: x0 and y0 do not have the same length');
+end
+
+%get maxiter and precision
+if nargin==9
+	maxiter=varargin{1};%maximum number of iterations
+	precision=varargin{2}; %division of each segment (higer precision increases number of segments)
+else
+	maxiter=200; %maximum number of iterations
+	precision=1; %division of each segment (higer precision increases number of segments)
+end
+
+%check seed points
+tria=TriaSearch(index,x,y,x0,y0);
+pos=find(isnan(tria));
+x0(pos)=[];
+y0(pos)=[];
+
+%initialize other variables
+N=length(x0);
+X=x0; Y=y0;
+flowpath=struct('x',cell(N,1),'y',cell(N,1),'name','','density',1);
+for i=1:N,
+	flowpath(i).x=x0(i);
+	flowpath(i).y=y0(i);
+end
+done=zeros(N,1);
+
+%get avegared length of each element
+length_tria=1/3*(sqrt( (x(index(:,1))-x(index(:,2))).^2+(y(index(:,1))-y(index(:,2))).^2 )+...
+	sqrt((x(index(:,1))-x(index(:,3))).^2+(y(index(:,1))-y(index(:,3))).^2 )+...
+	sqrt((x(index(:,2))-x(index(:,3))).^2+(y(index(:,2))-y(index(:,3))).^2 ));
+
+%take velocity for each element
+u=u(index)*[1;1;1]/3;
+v=v(index)*[1;1;1]/3;
+
+%initialization:
+counter=1;
+
+while any(~done) 
+
+	%find current triangle
+	queue=find(~done);
+	tria=TriaSearch(index,x,y,X(queue),Y(queue));
+
+	%check that the point is actually inside a triangle of the mesh
+	listnan=find(isnan(tria));
+	for i=1:length(listnan)
+		%remove the last point
+		flowpath(queue(listnan(i))).x(end)=[];
+		flowpath(queue(listnan(i))).y(end)=[];
+		done(queue(listnan(i)))=1;
+	end
+	tria(listnan)=[]; 
+	queue(listnan)=[];
+
+	if isempty(tria),
+		break;
+	end
+
+	%velocity of the current triangle and norm it
+	ut=u(tria); vt=v(tria); normv=sqrt(ut.^2+vt.^2);
+	ut=ut./normv;vt=vt./normv;
+
+	%check counter
+	if counter>maxiter
+		disp(['Maximum number of iterations (' num2str(maxiter) ') reached while going forward'])
+		break
+	end
+	counter=counter+1;
+
+	%remove stagnant point
+	done(queue(find(ut==0 & vt==0)))=1;
+
+	%build next point
+	for i=1:length(queue)
+		X(queue(i))=flowpath(queue(i)).x(end)+ut(i)*length_tria(tria(i))/precision;
+		Y(queue(i))=flowpath(queue(i)).y(end)+vt(i)*length_tria(tria(i))/precision;
+		flowpath(queue(i)).x=[flowpath(queue(i)).x;flowpath(queue(i)).x(end)+ut(i)*length_tria(tria(i))/precision];
+		flowpath(queue(i)).y=[flowpath(queue(i)).y;flowpath(queue(i)).y(end)+vt(i)*length_tria(tria(i))/precision];
+	end
+end
Index: issm/trunk/src/m/exp/expbox.m
===================================================================
--- issm/trunk/src/m/exp/expbox.m	(revision 13395)
+++ issm/trunk/src/m/exp/expbox.m	(revision 13395)
@@ -0,0 +1,41 @@
+function expbox(filename)
+%EXPBOX - Create an ARGUS file using two clicks
+%
+%   Two clicks on a plot are used to generate a rectangular box
+%   This box is written in EXP format on filename
+%
+%   Usage:
+%      expbox(filename)
+
+%check
+if exist(filename,'file'),
+	choice=input(['A file ' filename ' already exists, do you want to modify it? (y/n)'],'s');
+	if ~strcmpi(choice,'y'),
+		disp('no modification done ... exiting');
+		return
+	end
+end
+
+%Get points
+disp('Click twice to define a rectangular domain. First click for upper left corner, second for lower right corner');
+[x,y]=ginput(2);
+
+x1=x(1);
+x2=x(2);
+x3=x2;
+x4=x1;
+
+y1=y(1);
+y2=y1;
+y3=y(2);
+y4=y3;
+
+%Build Exp structure
+A=struct();
+A.nods=5;
+A.density=1;
+A.x=[x1 x2 x3 x4 x1]';
+A.y=[y1 y2 y3 y4 y1]';
+
+%Write structure
+expwrite(A,filename);
Index: issm/trunk/src/m/exp/expcircle.m
===================================================================
--- issm/trunk/src/m/exp/expcircle.m	(revision 13395)
+++ issm/trunk/src/m/exp/expcircle.m	(revision 13395)
@@ -0,0 +1,31 @@
+function expcircle(filename,x0,y0,radius,numberofnodes)
+%EXPCIRCLE - create a circular contour corresponding to given parameters
+%
+%   Creates a closed argus contour centered on x,y of radius size.
+%   The contour is made of numberofnodes
+%
+%   Usage:
+%      expcircle(filename,x0,y0,radius,numberofnodes)
+%
+%   See also EXPMASTER, EXPDOC
+
+%Calculate the cartesians coordinates of the points
+x_list=ones(numberofnodes+1,1);
+y_list=ones(numberofnodes+1,1);
+
+theta=(0:2*pi/numberofnodes:2*pi*(1-1/numberofnodes))';
+theta=[theta;0];
+
+x_list=radius*x_list.*cos(theta);
+y_list=radius*y_list.*sin(theta);
+
+%offset x_list and y_list by x0 and y0:
+x_list=x_list+x0;
+y_list=y_list+y0;
+
+contour.x=x_list;
+contour.y=y_list;
+contour.density=1;
+contour.name='circle';
+
+expwrite(contour,filename);
Index: issm/trunk/src/m/exp/expcoarsen.m
===================================================================
--- issm/trunk/src/m/exp/expcoarsen.m	(revision 13395)
+++ issm/trunk/src/m/exp/expcoarsen.m	(revision 13395)
@@ -0,0 +1,74 @@
+function expcoarsen(newfile,oldfile,resolution);
+%EXPCOARSEN - coarsen an exp contour
+%
+%   This routine read an Argus file and remove points with respect to
+%   the resolution (in meters) given in input. 
+%
+%   Usage:
+%      expcoarsen(newfile,oldfile,resolution)
+%
+%   Example:
+%       expcoarsen('DomainOutline.exp','Antarctica.exp',4000)
+
+%Some checks
+if nargin~=3 | nargout
+	error('expcoarsen usage: expcoarsen(newfile,oldfile,resolution)')
+elseif ~exist(oldfile)
+	error(['expcut error message: the file ' oldfile ' does not exist'])
+elseif exist(newfile),
+	choice=input(['A file ' newfile ' already exists, do you want to modify it? (y/n)'],'s');
+	if ~strcmpi(choice,'y'),
+		disp('no modification done ... exiting');
+		return;
+	end
+end
+
+%Get exp oldfile
+[path root ext ver]=fileparts(oldfile);
+A=expread(oldfile);
+numprofiles=size(A,2);
+
+%Go through the profiles
+count=1;
+while count<=numprofiles,
+
+	%get number of points and initialize j
+	numpoints=length(A(count).x);
+	j=1;
+
+	%stop if we have reached end of profile (always keep the last point)
+	while j<numpoints,
+
+		%See whether we keep this point or not
+		distance=sqrt((A(count).x(j)-A(count).x(j+1))^2+(A(count).y(j)-A(count).y(j+1))^2);
+		if distance<resolution & j<numpoints-1  %do not remove last point
+			A(count).x(j+1)=[];
+			A(count).y(j+1)=[];
+			numpoints=numpoints-1;
+		else
+			division=floor(distance/resolution)+1;
+			if division>=2,
+				x=linspace(A(count).x(j),A(count).x(j+1),division)';
+				y=linspace(A(count).y(j),A(count).y(j+1),division)';
+				A(count).x=[A(count).x(1:j);x(2:end-1); A(count).x(j+1:end)];
+				A(count).y=[A(count).y(1:j);y(2:end-1); A(count).y(j+1:end)];
+
+				%update current point
+				j=j+1+division-2;
+				numpoints=numpoints+division-2;
+			else
+				%update current point
+				j=j+1;
+			end
+		end
+	end
+	if length(A(count).x)<=1,
+		A(count)=[];
+		numprofiles=numprofiles-1;
+	else
+		count=count+1;
+	end
+end
+
+%write output
+expwrite(A,newfile);
Index: issm/trunk/src/m/exp/expcontract.m
===================================================================
--- issm/trunk/src/m/exp/expcontract.m	(revision 13395)
+++ issm/trunk/src/m/exp/expcontract.m	(revision 13395)
@@ -0,0 +1,34 @@
+function normal_node=expcontract(newfile,oldfile,distance)
+%EXPCONTRACT - contract or expand a profile, according to the normal.
+% 
+%   Usage:
+%      expcontract(newfile,oldfile,distance)
+%
+%   See also EXPMASTER, EXPDOC
+
+
+contour=expread(oldfile);
+num=numel(contour.x);
+
+normal=zeros(num-1,2);
+normal_node=zeros(num-1,2);
+
+for i=1:num-1,
+	normal(i,:)=[ contour.y(i)-contour.y(i+1) contour.x(i+1)-contour.x(i)];
+	normal(i,:)=normal(i,:)/sqrt(normal(i,1)^2+normal(i,2)^2);
+end
+
+normal_node(2:end,:)=[normal(1:end-1,:)+normal(2:end,:)];
+normal_node(1,:)=normal(1,:)+normal(end,:);
+
+normal_node_norm=sqrt(normal_node(:,1).^2+normal_node(:,2).^2);
+normal_node(:,1)=normal_node(:,1)./normal_node_norm;
+normal_node(:,2)=normal_node(:,2)./normal_node_norm;
+
+contour.x(1:end-1)=contour.x(1:end-1)+distance*normal_node(:,1);
+contour.y(1:end-1)=contour.y(1:end-1)+distance*normal_node(:,2);
+
+contour.x(end)=contour.x(1);
+contour.y(end)=contour.y(1);
+
+expwrite(contour,newfile);
Index: issm/trunk/src/m/exp/expcreatecontour.m
===================================================================
--- issm/trunk/src/m/exp/expcreatecontour.m	(revision 13395)
+++ issm/trunk/src/m/exp/expcreatecontour.m	(revision 13395)
@@ -0,0 +1,36 @@
+function expcreatecontour(filename);
+%EXPCREATECONTOUR - create a contour from a list of points
+%
+%   expcreatecontour: from a list of (x,y) points (retrieve using ginput on an undetermined
+%   number of points: used RETURN key to end input), create an Argus .exp 
+%   file holding the corresponding closed contour.
+%    
+%   Usage:
+%      expcreatecontour(filename)
+%
+%   See also EXPMASTER, EXPDOC
+
+%Get root of filename
+[path root ext ver]=fileparts(filename);
+
+%Get contour
+disp('Click on contour points you desire. Type RETURN to end input of points');
+[x,y]=ginput();
+
+%close contour
+x=[x;x(1)];
+y=[y;y(1);];
+
+%plot contour
+hold on;
+plot(x,y,'r-');
+
+%create structure for expwrite routine
+a.x=x;
+a.y=y;
+a.name=root;
+a.density=1;
+
+%write contour using expwrite
+expwrite(a,filename);
+
Index: issm/trunk/src/m/exp/expcreateprofile.m
===================================================================
--- issm/trunk/src/m/exp/expcreateprofile.m	(revision 13395)
+++ issm/trunk/src/m/exp/expcreateprofile.m	(revision 13395)
@@ -0,0 +1,31 @@
+function expcreateprofile(filename);
+%EXPCREATEPROFILE - create an Argus file from a list of points
+%
+%   expcreateprofile: from a list of (x,y) points (retrieve using ginput on an undetermined
+%   number of points: used RETURN key to end input), create an Argus .exp 
+%   file holding the corresponding open profile.
+%    
+%   Usage:
+%      expcreateprofile(filename)
+%
+%   See also EXPMASTER, EXPDOC
+
+%Get root of filename
+[path root ext ver]=fileparts(filename);
+
+%Get profile
+disp('Click on profile points you desire. Type RETURN to end input of points');
+[x,y]=ginput();
+
+%plot contour
+hold on;
+plot(x,y,'r-');
+
+%create structure for expwrite routine
+a.x=x;
+a.y=y;
+a.name=root;
+a.density=1;
+
+%write profile using expwrite
+expwrite(a,filename);
Index: issm/trunk/src/m/exp/expdisp.m
===================================================================
--- issm/trunk/src/m/exp/expdisp.m	(revision 13395)
+++ issm/trunk/src/m/exp/expdisp.m	(revision 13395)
@@ -0,0 +1,52 @@
+function expdisp(domainoutline,varargin)
+%EXPDISP - plot the contours of a domain outline file
+%
+%   This routine reads in a domain outline file (Argus format) and plots all the contours 
+%
+%   Usage:
+%      expdisp(domainoutline,varargin)
+%      expdisp(domainoutline,figurenumber,linestyle,linewidth,unitmultiplier)
+%
+%   Example:
+%      expdisp('Domain.exp',1,'--r',2,10^3);
+%
+%   See also EXPMASTER, EXPDOC
+
+%check nargin
+if ~nargin | nargin>5
+	help expdisp
+	error('expdisp error message: bad usage');
+end
+
+%parse input
+if nargin<=1,
+	figurenumber=1;
+else
+	figurenumber=varargin{1};
+end
+if nargin<=2
+	linestyle='r-';
+else
+	linestyle=varargin{2};
+end
+if nargin<=3
+	linewidth=1;
+else
+	linewidth=varargin{3};
+end
+if nargin<=4
+	unitmultiplier=1;
+else
+	unitmultiplier=varargin{4}; if isnan(unitmultiplier), unitmultiplier=1; end
+end
+
+domain=expread(domainoutline);
+
+figure(figurenumber),hold on
+for i=1:length(domain),
+	if (isnumeric(linestyle))
+		plot(domain(i).x*unitmultiplier,domain(i).y*unitmultiplier,'Color',linestyle,'linewidth',linewidth);
+	else
+		plot(domain(i).x*unitmultiplier,domain(i).y*unitmultiplier,linestyle,'linewidth',linewidth);
+	end
+end
